#!/bin/bash
######################################################################################################
#
# Copyright (c) 2013, Heiko Schäfer <heiko@rangun.de>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are permitted
# provided that the following conditions are met:
#
# Redistributions of source code must retain the above copyright notice, this list of conditions and
# the following disclaimer.
#
# Redistributions in binary form must reproduce the above copyright notice, this list of conditions
# and the following disclaimer in the documentation and/or other materials provided with the
# distribution.
#
# THIS SOFTWARE IS PROVIDED BY Heiko Schäfer <heiko@rangun.de> "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Heiko Schäfer <heiko@rangun.de>
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
# THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
######################################################################################################

if [ -z "$3" -o -z "$2" -o -z "$1" ]; then
  echo "Usage: $0 input.hglz output.img IMGTYPE"
  exit 1
fi

if [ -z "$HGL" ]; then
  HGL=hgl
fi

TEXT='Rendering '$1' to '$2'...'

if [ "$DISPLAY" -a "`which zenity`" ]; then
  DIALOG=zenity
  PROGRESS="--text '$(echo $TEXT)' --progress --auto-kill"
else
  DIALOG=dialog
  PROGRESS="--gauge '\n$(echo "$TEXT")' 8 75"
fi

CMD="$DIALOG --title ' HGL progress example ' $PROGRESS"

$HGL --quiet $1 -C -O $3 -o $2 2>&1 | gawk '/^[0-9]+(\\.[0-9]+)?/ { print int($0); fflush(); }' | \
	eval $CMD
